<?php

class controller_component_generator extends component
{
    public function action_index()
    {
        $this->data['errors'] = array();
        $this->data['sysname'] = '';
        $this->data['name'] = '';
        $this->data['element_name'] = '';
        $this->data['element_add_name'] = '';

        if (isset($_POST['create_component'])) {
            $this->data['sysname'] = $_POST['sysname'];

            if ($this->data['sysname'] == '') {
                $this->data['errors'][] = 'Системное имя не может быть пустым';
            } elseif (preg_match('/[a-zA-Z_][a-zA-Z_0-9]*/', $this->data['sysname']) === 0) {
                $this->data['errors'][] = 'Системное имя может содержать только символы латинского алфавита, цифры и подчеркивание и не может начинаться с цифры';
            } elseif (is_dir(ROOT_DIR.'/modules/components/'.$this->data['sysname']) || is_dir(ROOT_DIR.'/user_cms/modules/components/'.$this->data['sysname'])) {
                $this->data['errors'][] = 'Компонент с таким системным именем уже существует';
            } elseif ($this->model->table_exists($this->data['sysname'])){
                $this->data['errors'][] = 'В базе данных уже есть таблица с таким системным именем';
            }

            $this->data['name'] = $_POST['name'];
            if ($this->data['name'] == '') {
                $this->data['errors'][] = 'Укажите название компонента';
            }

            $this->data['element_name'] = $_POST['element_name'];
            if ($this->data['element_name'] == '') {
                $this->data['errors'][] = 'Укажите название элемента';
            }

            $this->data['element_add_name'] = $_POST['element_add_name'];
            if ($this->data['element_add_name'] == '') {
                $this->data['errors'][] = 'Укажите надпись на кнопке создания элемента';
            }

            if (empty($this->data['errors'])) {
                if ($this->model->generate_component($this->data)) {
                    $this->redirect('/admin/components_manager/activate/'.$this->data['sysname']);
                } else {
                    $this->data['errors'][] = 'Не удалось создать компонент.';
                }
            }

        }

        $this->page['html'] = $this->load_view();
        $this->page['title'] = 'Генератор каталогов';
        return $this->page;
    }
}